\chapter{Threats to the Approach}

This chapter lists threats to the chosen acceleration approach and the validity of the evaluation.

\begin{enumerate}
  \item Acceleration might significantly vary across different devices, depending on the available CPU power.

  \item Choosing a combination of acceleration options that produces stable test results is currently based on the user's experience and differs on each platform (see 1.). New users might choose a combination of acceleration options initially, which increases the error rate. This will negatively impact the user experience if the users are not aware of this.

  \item In general, Chrome and Puppeteer can utilize GPU based hardware acceleration. The current Servant does disable it via the \texttt{--disable-gpu} flag, which is passed to the Headless-Chrome instance, to avoid crashes and compatibility issues with Linux based hosts. This should be changed in the future when GPU acceleration becomes more stable on Linux, which has been an ongoing topic within the Chrome/Chromium development.

  \item Making entirely sure that tests that work with an acceleration factor of 1 also work without any increased failure rate at higher frequencies can not be guaranteed. When working with a collection of Scratch applications for evaluation and testing purposes of the approaches, the author noticed that some of the test-suite implementations are based on randomness or \textit{hope}.

  This is an excerpt of the \textit{Catch Game} integration test with such a case:
  \begin{lstlisting}[language=ES6]
  /* Run and hope that the banana randomly touches the bowl. */
  appleTouched = false;
  await t.runForTime(30000);
  t.assume.equal(bananaTouched, 'bowl', 'Banana didn\'t touch the bowl after 30 seconds.');
  if (appleTouched) {
      t.log(`Apple touched the ${appleTouched} before the banana touched the bowl.`);
  }
  \end{lstlisting}

  \item Tests evaluating a constraint after a specific time interval might fail because the application logic does not define the interval. Instead, the test author estimated the interval while writing the test via trial and error. If such an estimate is off by a bit, no error might occur or only in rare cases when executed with an acceleration factor of 1, but more often with an acceleration factor of 10. Also, the test can be run more often when executed with a higher frequency, and therefore even under an unchanged failure rate, the absolute failure count might increase.

  \item As the headless option allows to use Whisker in the background, the user is not blocked from running long test-suite executions (also controllable from another script), while continuing to use their computer for other tasks. This might be convenient, but combining a test-suite run with a high CPU load with another CPU intensive task might also break tests. On the author's platform described in the \textit{Evaluation} chapter, running test-suites with an acceleration factor of 10 and using the computer for simple web browsing was not interfering with the test execution. On the other hand, compiling a Linux kernel and running tests in parallel did increase the test-failure rate.
\end{enumerate}
